WITH Ada.Integer_Text_IO;
WITH Ada.Float_Text_IO;
WITH Ada.Text_IO;
PROCEDURE Attributes IS
--------------------------------------------------------------
--| Displays various integer and float attributes
--| Author: M. B. Feldman, The George Washington University 
--| Last Modified: August 1998 
--------------------------------------------------------------

BEGIN -- Attributes

  Ada.Text_IO.Put(Item => "Smallest integer is ");
  Ada.Integer_Text_IO.Put(Item => Integer'First);
  Ada.Text_IO.New_Line;
  Ada.Text_IO.Put(Item => "Largest integer is ");
  Ada.Integer_Text_IO.Put(Item => Integer'Last);
  Ada.Text_IO.New_Line;
  Ada.Text_IO.Put(Item => "Bits in an integer ");
  Ada.Integer_Text_IO.Put(Item => Integer'Size, Width => 1);
  Ada.Text_IO.New_Line;

  Ada.Text_IO.Put(Item => "Smallest float is ");
  Ada.Float_Text_IO.Put(Item => Float'First);
  Ada.Text_IO.New_Line;
  Ada.Text_IO.Put(Item => "Largest float is ");
  Ada.Float_Text_IO.Put(Item => Float'Last);
  Ada.Text_IO.New_Line;
  Ada.Text_IO.Put(Item => "Bits in a float ");
  Ada.Integer_Text_IO.Put(Item => Float'Size, Width => 1);
  Ada.Text_IO.New_Line;
  Ada.Text_IO.Put(Item => "Bits in a mantissa ");
  Ada.Integer_Text_IO.Put(Item => Float'Mantissa, Width => 1);
  Ada.Text_IO.New_Line;

END Attributes;
