WITH Ada.Text_IO;
WITH Ada.Integer_Text_IO;
PROCEDURE Multiply_Integers IS
--------------------------------------------------------------
--| Finds the product of a collection of non-zero integers.
--| If there are multiple consecutive occurrences of the same
--| value, only the first value is included in the product.
--| Author: M. B. Feldman, The George Washington University
--| Last Modified: August 1998
--------------------------------------------------------------

  Sentinel : CONSTANT Natural := 0;  -- sentinel value

  NextNum :     Integer;        -- input - new data item
  PreviousNum : Integer;        -- save previous data item
  Product :     Integer;        -- output - product of data

BEGIN -- Multiply_Integers

  Product := 1;
  PreviousNum := Sentinel;
  Ada.Text_IO.Put (Item => "Enter 0 to stop.");
  Ada.Text_IO.New_Line;
  Ada.Text_IO.Put (Item => "Enter first number > ");
  Ada.Integer_Text_IO.Get (Item => NextNum); -- priming read

  LOOP
    EXIT WHEN NextNum = Sentinel;

    IF NextNum /= PreviousNum THEN
      Product := Product * NextNum; -- compute next product
    END IF;
    PreviousNum := NextNum;         -- remember previous item
    Ada.Text_IO.Put (Item => "Enter next  number  > ");
    Ada.Integer_Text_IO.Get (Item => NextNum);
  END LOOP;

  Ada.Text_IO.Put (Item => "The product is ");
  Ada.Integer_Text_IO.Put(Item => Product, Width => 1);
  Ada.Text_IO.New_Line;

END Multiply_Integers;


