WITH Ada.Text_IO;
WITH Ada.Integer_Text_IO;
WITH Useful_Functions;
PROCEDURE Robust_Sum_Fact IS
--------------------------------------------------------------
--| Prompts the user for an integer N from 1 to 50
--| and displays the sum and factorial of all integers from
--| 1 to N. Sum and Factorial are gotten from the package
--| Useful_Functions.
--| This version incorporates an exception handler part.
--| Author: M. B. Feldman, The George Washington University
--| Last Modified: August 1998
--------------------------------------------------------------

  SUBTYPE OneToFifty IS Positive RANGE 1..50;

  MaxNum:       OneToFifty; -- input - a value from one to ten
  SumToCount:   Positive;   -- outputs - sum and product of
  ProdToCount:  Positive;   --   integers from one to Count

BEGIN -- Robust_Sum_Fact

  Ada.Text_IO.Put (Item => "Please enter an integer from 1 to 50 > ");
  Ada.Integer_Text_IO.Get (Item => MaxNum);
  Ada.Text_IO.New_Line;

  Ada.Text_IO.Put(Item => "  N    Sum    Factorial");
  Ada.Text_IO.New_Line;
  Ada.Text_IO.Put(Item => "  ----------------------");
  Ada.Text_IO.New_Line;

  FOR Count IN 1..MaxNum LOOP
    SumToCount   := Useful_Functions.Sum (N => Count);
    ProdToCount  := Useful_Functions.Factorial (N => Count);

    Ada.Integer_Text_IO.Put (Item => Count, Width => 3);
    Ada.Integer_Text_IO.Put (Item => SumToCount, Width => 7);
    Ada.Integer_Text_IO.Put (Item => ProdToCount, Width => 9);
    Ada.Text_IO.New_Line;
  END LOOP;

EXCEPTION

  WHEN Constraint_Error =>
    Ada.Text_IO.Put
      (Item => "The input value or result is out of range.");
    Ada.Text_IO.New_Line;
  WHEN Ada.Text_IO.Data_Error =>
    Ada.Text_IO.Put (Item => "The input value is not well formed.");
    Ada.Text_IO.New_Line;

END Robust_Sum_Fact;

