WITH Ada.Text_IO;
WITH Ada.Calendar;
WITH Ada.Integer_Text_IO;
PROCEDURE Todays_Date IS
--------------------------------------------------------------
--| Finds and displays today's date in the form mm/dd/yyyy
--| Author: M. B. Feldman, The George Washington University
--| Last Modified: July 1998
--------------------------------------------------------------
  RightNow  : Ada.Calendar.Time;           -- current time
  ThisYear  : Ada.Calendar.Year_Number;    -- current year
  ThisMonth : Ada.Calendar.Month_Number;   -- current month
  ThisDay   : Ada.Calendar.Day_Number;     -- current day

BEGIN -- Todays_Date

  -- Get the current time value from the computer's clock
  RightNow := Ada.Calendar.Clock;

  -- Extract current month, day, and year from the time value
  ThisMonth := Ada.Calendar.Month(Date => RightNow);
  ThisDay   := Ada.Calendar.Day  (Date => RightNow);
  ThisYear  := Ada.Calendar.Year (Date => RightNow);

  -- Format and display the date
  Ada.Text_IO.Put (Item => "Today's date is ");
  Ada.Integer_Text_IO.Put (Item => ThisMonth, Width => 1);
  Ada.Text_IO.Put (Item => '/');
  Ada.Integer_Text_IO.Put (Item => ThisDay, Width => 1);
  Ada.Text_IO.Put (Item => '/');
  Ada.Integer_Text_IO.Put (Item => ThisYear, Width => 1);
  Ada.Text_IO.New_Line;

END Todays_Date;
